/* A Bison parser, made by GNU Bison 2.4.2.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2006, 2009-2010 Free Software
   Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0

/* Substitute the variable and function names.  */
#define yyparse         parser_parse
#define yylex           parser_lex
#define yyerror         parser_error
#define yylval          parser_lval
#define yychar          parser_char
#define yydebug         parser_debug
#define yynerrs         parser_nerrs


/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 19 "parser.y"


#include "vbscript.h"
#include "parse.h"

#include "wine/debug.h"

WINE_DEFAULT_DEBUG_CHANNEL(vbscript);

#define YYLEX_PARAM ctx
#define YYPARSE_PARAM ctx

static int parser_error(const char*);

static void parse_complete(parser_ctx_t*,BOOL);

static void source_add_statement(parser_ctx_t*,statement_t*);
static void source_add_class(parser_ctx_t*,class_decl_t*);

static void *new_expression(parser_ctx_t*,expression_type_t,size_t);
static expression_t *new_bool_expression(parser_ctx_t*,VARIANT_BOOL);
static expression_t *new_string_expression(parser_ctx_t*,const WCHAR*);
static expression_t *new_long_expression(parser_ctx_t*,expression_type_t,LONG);
static expression_t *new_double_expression(parser_ctx_t*,double);
static expression_t *new_unary_expression(parser_ctx_t*,expression_type_t,expression_t*);
static expression_t *new_binary_expression(parser_ctx_t*,expression_type_t,expression_t*,expression_t*);
static expression_t *new_new_expression(parser_ctx_t*,const WCHAR*);

static member_expression_t *new_member_expression(parser_ctx_t*,expression_t*,const WCHAR*);

static void *new_statement(parser_ctx_t*,statement_type_t,size_t);
static statement_t *new_call_statement(parser_ctx_t*,member_expression_t*);
static statement_t *new_assign_statement(parser_ctx_t*,member_expression_t*,expression_t*);
static statement_t *new_set_statement(parser_ctx_t*,member_expression_t*,expression_t*);
static statement_t *new_dim_statement(parser_ctx_t*,dim_decl_t*);
static statement_t *new_while_statement(parser_ctx_t*,statement_type_t,expression_t*,statement_t*);
static statement_t *new_forto_statement(parser_ctx_t*,const WCHAR*,expression_t*,expression_t*,expression_t*,statement_t*);
static statement_t *new_foreach_statement(parser_ctx_t*,const WCHAR*,expression_t*,statement_t*);
static statement_t *new_if_statement(parser_ctx_t*,expression_t*,statement_t*,elseif_decl_t*,statement_t*);
static statement_t *new_function_statement(parser_ctx_t*,function_decl_t*);
static statement_t *new_onerror_statement(parser_ctx_t*,BOOL);
static statement_t *new_const_statement(parser_ctx_t*,const_decl_t*);

static dim_decl_t *new_dim_decl(parser_ctx_t*,const WCHAR*,dim_decl_t*);
static elseif_decl_t *new_elseif_decl(parser_ctx_t*,expression_t*,statement_t*);
static function_decl_t *new_function_decl(parser_ctx_t*,const WCHAR*,function_type_t,unsigned,arg_decl_t*,statement_t*);
static arg_decl_t *new_argument_decl(parser_ctx_t*,const WCHAR*,BOOL);
static const_decl_t *new_const_decl(parser_ctx_t*,const WCHAR*,expression_t*);

static class_decl_t *new_class_decl(parser_ctx_t*);
static class_decl_t *add_class_function(parser_ctx_t*,class_decl_t*,function_decl_t*);
static class_decl_t *add_variant_prop(parser_ctx_t*,class_decl_t*,const WCHAR*,unsigned);

static statement_t *link_statements(statement_t*,statement_t*);

static const WCHAR propertyW[] = {'p','r','o','p','e','r','t','y',0};

#define STORAGE_IS_PRIVATE    1
#define STORAGE_IS_DEFAULT    2

#define CHECK_ERROR if(((parser_ctx_t*)ctx)->hres != S_OK) YYABORT



/* Line 189 of yacc.c  */
#line 145 "parser.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     tEOF = 258,
     tNL = 259,
     tREM = 260,
     tEMPTYBRACKETS = 261,
     tTRUE = 262,
     tFALSE = 263,
     tNOT = 264,
     tAND = 265,
     tOR = 266,
     tXOR = 267,
     tEQV = 268,
     tIMP = 269,
     tNEQ = 270,
     tIS = 271,
     tLTEQ = 272,
     tGTEQ = 273,
     tMOD = 274,
     tCALL = 275,
     tDIM = 276,
     tSUB = 277,
     tFUNCTION = 278,
     tPROPERTY = 279,
     tGET = 280,
     tLET = 281,
     tCONST = 282,
     tIF = 283,
     tELSE = 284,
     tELSEIF = 285,
     tEND = 286,
     tTHEN = 287,
     tEXIT = 288,
     tWHILE = 289,
     tWEND = 290,
     tDO = 291,
     tLOOP = 292,
     tUNTIL = 293,
     tFOR = 294,
     tTO = 295,
     tSTEP = 296,
     tEACH = 297,
     tIN = 298,
     tBYREF = 299,
     tBYVAL = 300,
     tOPTION = 301,
     tEXPLICIT = 302,
     tSTOP = 303,
     tNOTHING = 304,
     tEMPTY = 305,
     tNULL = 306,
     tCLASS = 307,
     tSET = 308,
     tNEW = 309,
     tPUBLIC = 310,
     tPRIVATE = 311,
     tDEFAULT = 312,
     tME = 313,
     tERROR = 314,
     tNEXT = 315,
     tON = 316,
     tRESUME = 317,
     tGOTO = 318,
     tIdentifier = 319,
     tString = 320,
     tLong = 321,
     tShort = 322,
     tDouble = 323
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 86 "parser.y"

    const WCHAR *string;
    statement_t *statement;
    expression_t *expression;
    member_expression_t *member;
    elseif_decl_t *elseif;
    dim_decl_t *dim_decl;
    function_decl_t *func_decl;
    arg_decl_t *arg_decl;
    class_decl_t *class_decl;
    const_decl_t *const_decl;
    unsigned uint;
    LONG lng;
    BOOL bool;
    double dbl;



/* Line 214 of yacc.c  */
#line 268 "parser.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 280 "parser.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   772

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  85
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  52
/* YYNRULES -- Number of rules.  */
#define YYNRULES  145
/* YYNRULES -- Number of states.  */
#define YYNSTATES  296

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   323

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    78,     2,
      74,    75,    82,    79,    73,    80,    72,    83,    71,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    69,     2,
      77,    70,    76,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    81,     2,    84,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     7,     8,    12,    13,    16,    19,    20,
      22,    24,    27,    30,    32,    35,    37,    41,    44,    47,
      51,    56,    59,    61,    67,    74,    81,    83,    86,    89,
      92,    95,    98,   104,   106,   111,   116,   119,   130,   139,
     141,   145,   147,   151,   153,   157,   161,   163,   165,   166,
     169,   179,   184,   192,   193,   196,   197,   199,   201,   204,
     210,   211,   215,   217,   221,   223,   225,   227,   231,   232,
     234,   236,   240,   242,   246,   248,   252,   254,   258,   260,
     264,   266,   269,   271,   275,   279,   283,   287,   291,   295,
     299,   301,   305,   307,   311,   315,   317,   321,   323,   327,
     329,   333,   337,   339,   343,   345,   347,   350,   353,   355,
     358,   360,   362,   364,   366,   368,   370,   372,   374,   376,
     378,   382,   384,   392,   393,   397,   402,   406,   416,   428,
     440,   449,   458,   459,   461,   464,   466,   468,   470,   474,
     476,   480,   482,   485,   488,   490
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
      86,     0,    -1,    87,    88,     3,    -1,    -1,    46,    47,
       4,    -1,    -1,    88,    91,    -1,    88,   127,    -1,    -1,
      90,    -1,    91,    -1,    91,    90,    -1,    92,     4,    -1,
      69,    -1,    69,    92,    -1,    93,    -1,    93,    69,    92,
      -1,    93,    69,    -1,    94,   107,    -1,    20,    94,   106,
      -1,    94,   106,    70,   110,    -1,    21,    95,    -1,   100,
      -1,    34,   110,     4,    89,    35,    -1,    36,    98,   110,
       4,    89,    37,    -1,    36,     4,    89,    37,    98,   110,
      -1,   130,    -1,    33,    36,    -1,    33,    39,    -1,    33,
      23,    -1,    33,    24,    -1,    33,    22,    -1,    53,    94,
     106,    70,   110,    -1,    48,    -1,    61,    59,    62,    60,
      -1,    61,    59,    63,    71,    -1,    27,    96,    -1,    39,
     136,    70,   110,    40,   110,    99,     4,    89,    60,    -1,
      39,    42,   136,    43,   110,     4,    89,    60,    -1,   136,
      -1,   124,    72,   136,    -1,   136,    -1,   136,    73,    95,
      -1,    97,    -1,    97,    73,    96,    -1,   136,    70,   125,
      -1,    34,    -1,    38,    -1,    -1,    41,   110,    -1,    28,
     110,    32,     4,    90,   102,   105,    31,    28,    -1,    28,
     110,    32,    92,    -1,    28,   110,    32,    92,    29,    92,
     101,    -1,    -1,    31,    28,    -1,    -1,   103,    -1,   104,
      -1,   104,   103,    -1,    30,   110,    32,     4,    90,    -1,
      -1,    29,     4,    90,    -1,   109,    -1,    74,   108,    75,
      -1,   109,    -1,   108,    -1,   110,    -1,   110,    73,   108,
      -1,    -1,     6,    -1,   111,    -1,   110,    14,   111,    -1,
     112,    -1,   111,    13,   112,    -1,   113,    -1,   112,    12,
     113,    -1,   114,    -1,   113,    11,   114,    -1,   115,    -1,
     114,    10,   115,    -1,   116,    -1,     9,   115,    -1,   117,
      -1,   116,    70,   117,    -1,   116,    15,   117,    -1,   116,
      76,   117,    -1,   116,    77,   117,    -1,   116,    18,   117,
      -1,   116,    17,   117,    -1,   116,    16,   117,    -1,   118,
      -1,   117,    78,   118,    -1,   119,    -1,   118,    79,   119,
      -1,   118,    80,   119,    -1,   120,    -1,   119,    19,   120,
      -1,   121,    -1,   120,    81,   121,    -1,   122,    -1,   121,
      82,   122,    -1,   121,    83,   122,    -1,   123,    -1,   122,
      84,   123,    -1,   125,    -1,   124,    -1,    54,   136,    -1,
      80,   123,    -1,   126,    -1,    94,   106,    -1,     7,    -1,
       8,    -1,    65,    -1,    67,    -1,    71,    -1,    66,    -1,
      68,    -1,    50,    -1,    51,    -1,    49,    -1,    74,   110,
      75,    -1,    58,    -1,    52,   136,     4,   128,    31,    52,
       4,    -1,    -1,   130,     4,   128,    -1,   132,    64,     4,
     128,    -1,   129,     4,   128,    -1,   131,    24,    25,    64,
     109,     4,    89,    31,    24,    -1,   131,    24,    26,    64,
      74,   135,    75,     4,    89,    31,    24,    -1,   131,    24,
      53,    64,    74,   135,    75,     4,    89,    31,    24,    -1,
     131,    22,   136,   133,     4,    89,    31,    22,    -1,   131,
      23,   136,   133,     4,    89,    31,    23,    -1,    -1,   132,
      -1,    55,    57,    -1,    55,    -1,    56,    -1,   109,    -1,
      74,   134,    75,    -1,   135,    -1,   135,    73,   134,    -1,
     136,    -1,    44,   136,    -1,    45,   136,    -1,    64,    -1,
      24,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   139,   139,   142,   143,   145,   147,   148,   151,   152,
     155,   156,   159,   162,   163,   164,   165,   166,   169,   170,
     171,   173,   174,   175,   177,   180,   183,   184,   185,   186,
     187,   188,   189,   191,   192,   193,   194,   195,   197,   201,
     202,   205,   206,   209,   210,   213,   216,   217,   220,   221,
     224,   226,   227,   230,   232,   235,   236,   239,   240,   243,
     247,   248,   251,   252,   255,   256,   259,   260,   262,   264,
     267,   268,   271,   272,   275,   276,   279,   280,   283,   284,
     287,   288,   291,   292,   293,   294,   295,   296,   297,   298,
     301,   302,   305,   306,   307,   310,   311,   314,   315,   319,
     320,   322,   326,   327,   330,   331,   332,   333,   336,   337,
     340,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     352,   353,   356,   359,   360,   361,   362,   365,   367,   369,
     373,   375,   379,   380,   383,   384,   385,   388,   389,   392,
     393,   396,   397,   398,   402,   403
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tEOF", "tNL", "tREM", "tEMPTYBRACKETS",
  "tTRUE", "tFALSE", "tNOT", "tAND", "tOR", "tXOR", "tEQV", "tIMP", "tNEQ",
  "tIS", "tLTEQ", "tGTEQ", "tMOD", "tCALL", "tDIM", "tSUB", "tFUNCTION",
  "tPROPERTY", "tGET", "tLET", "tCONST", "tIF", "tELSE", "tELSEIF", "tEND",
  "tTHEN", "tEXIT", "tWHILE", "tWEND", "tDO", "tLOOP", "tUNTIL", "tFOR",
  "tTO", "tSTEP", "tEACH", "tIN", "tBYREF", "tBYVAL", "tOPTION",
  "tEXPLICIT", "tSTOP", "tNOTHING", "tEMPTY", "tNULL", "tCLASS", "tSET",
  "tNEW", "tPUBLIC", "tPRIVATE", "tDEFAULT", "tME", "tERROR", "tNEXT",
  "tON", "tRESUME", "tGOTO", "tIdentifier", "tString", "tLong", "tShort",
  "tDouble", "':'", "'='", "'0'", "'.'", "','", "'('", "')'", "'>'", "'<'",
  "'&'", "'+'", "'-'", "'\\\\'", "'*'", "'/'", "'^'", "$accept", "Program",
  "OptionExplicit_opt", "SourceElements", "StatementsNl_opt",
  "StatementsNl", "StatementNl", "Statement", "SimpleStatement",
  "MemberExpression", "DimDeclList", "ConstDeclList", "ConstDecl",
  "DoType", "Step_opt", "IfStatement", "EndIf_opt", "ElseIfs_opt",
  "ElseIfs", "ElseIf", "Else_opt", "Arguments_opt", "ArgumentList_opt",
  "ArgumentList", "EmptyBrackets_opt", "Expression", "EqvExpression",
  "XorExpression", "OrExpression", "AndExpression", "NotExpression",
  "EqualityExpression", "ConcatExpression", "AdditiveExpression",
  "ModExpression", "IntdivExpression", "MultiplicativeExpression",
  "ExpExpression", "UnaryExpression", "CallExpression",
  "LiteralExpression", "PrimaryExpression", "ClassDeclaration",
  "ClassBody", "PropertyDecl", "FunctionDecl", "Storage_opt", "Storage",
  "ArgumentsDecl_opt", "ArgumentDeclList", "ArgumentDecl", "Identifier", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,    58,
      61,    48,    46,    44,    40,    41,    62,    60,    38,    43,
      45,    92,    42,    47,    94
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    85,    86,    87,    87,    88,    88,    88,    89,    89,
      90,    90,    91,    92,    92,    92,    92,    92,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    94,
      94,    95,    95,    96,    96,    97,    98,    98,    99,    99,
     100,   100,   100,   101,   101,   102,   102,   103,   103,   104,
     105,   105,   106,   106,   107,   107,   108,   108,   109,   109,
     110,   110,   111,   111,   112,   112,   113,   113,   114,   114,
     115,   115,   116,   116,   116,   116,   116,   116,   116,   116,
     117,   117,   118,   118,   118,   119,   119,   120,   120,   121,
     121,   121,   122,   122,   123,   123,   123,   123,   124,   124,
     125,   125,   125,   125,   125,   125,   125,   125,   125,   125,
     126,   126,   127,   128,   128,   128,   128,   129,   129,   129,
     130,   130,   131,   131,   132,   132,   132,   133,   133,   134,
     134,   135,   135,   135,   136,   136
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     3,     0,     3,     0,     2,     2,     0,     1,
       1,     2,     2,     1,     2,     1,     3,     2,     2,     3,
       4,     2,     1,     5,     6,     6,     1,     2,     2,     2,
       2,     2,     5,     1,     4,     4,     2,    10,     8,     1,
       3,     1,     3,     1,     3,     3,     1,     1,     0,     2,
       9,     4,     7,     0,     2,     0,     1,     1,     2,     5,
       0,     3,     1,     3,     1,     1,     1,     3,     0,     1,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     3,
       1,     2,     1,     3,     3,     3,     3,     3,     3,     3,
       1,     3,     1,     3,     3,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     1,     1,     2,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     1,     7,     0,     3,     4,     3,     9,    11,    11,
       8,     8,     0,     1,     2,     1,     1,     1,     3,     1,
       3,     1,     2,     2,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       3,     0,     0,     5,     0,     1,   132,     4,     2,     0,
       0,   145,     0,     0,     0,     0,     0,     0,    33,     0,
       0,   135,   136,   121,     0,   144,    13,     0,     6,     0,
      15,    68,    22,     0,   108,     7,    26,     0,   133,    39,
      68,    21,    41,    36,    43,     0,   110,   111,     0,   119,
     117,   118,     0,   112,   115,   113,   116,   114,     0,    68,
       0,    70,    72,    74,    76,    78,    80,    82,    90,    92,
      95,    97,    99,   102,   105,   104,    31,    29,    30,    27,
      28,     0,   132,    46,    47,     0,     0,     0,     0,    68,
     134,     0,    14,     0,    12,    17,    69,     0,   109,    18,
      65,    64,    66,     0,     0,     0,     0,    19,    62,     0,
       0,     0,    81,   106,   107,   109,     0,   132,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   132,     0,     9,
      10,     0,     0,     0,   132,   109,     0,     0,   120,    16,
       0,     0,     0,     0,    40,    68,    68,    42,    44,    45,
      71,   132,    51,    73,    75,    77,    79,    84,    89,    88,
      87,    83,    85,    86,    91,    93,    94,    96,    98,   100,
     101,   103,     0,     0,    11,   132,     0,     0,     0,     0,
       0,     0,   133,     0,    34,    35,    63,    20,    67,     0,
     137,     0,     0,    55,   132,    23,     0,     0,     0,     0,
       0,   132,   132,     0,     0,    32,     0,     0,     0,   139,
     141,   132,   132,     0,    60,    56,    57,    53,    25,    24,
     132,    48,     0,   126,   124,     0,     0,     0,   132,   142,
     143,   138,     0,     0,     0,     0,     0,     0,    58,     0,
      52,     0,     0,     0,   122,    68,     0,     0,   125,   140,
       0,     0,     0,   132,     0,    54,    38,    49,   132,     0,
       0,     0,   130,   131,   132,    61,    50,     0,   132,     0,
       0,    59,    37,     0,     0,     0,     0,   132,   132,   127,
       0,     0,     0,     0,   128,   129
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     6,   138,   139,   140,    29,    30,    59,
      41,    43,    44,    85,   253,    32,   250,   224,   225,   226,
     247,    98,    99,   150,   108,   102,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    34,    35,   188,   189,    36,    37,    38,   201,   218,
     219,    39
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -156
static const yytype_int16 yypact[] =
{
     -10,    74,    64,  -156,   120,  -156,   385,  -156,  -156,   -16,
       2,  -156,     2,   299,    79,   299,    31,     8,  -156,     2,
     -16,    70,  -156,  -156,    73,  -156,   479,   299,  -156,   125,
      66,   271,  -156,    78,  -156,  -156,  -156,    83,  -156,  -156,
      11,  -156,    69,  -156,    72,    84,  -156,  -156,   299,  -156,
    -156,  -156,     2,  -156,  -156,  -156,  -156,  -156,   336,    11,
       9,   165,   168,   178,   181,  -156,   159,   118,    68,   180,
     116,    89,   117,  -156,    78,  -156,  -156,  -156,  -156,  -156,
    -156,    45,   518,  -156,  -156,   299,     2,   132,   200,    11,
    -156,    54,  -156,    13,  -156,   479,  -156,   299,   135,  -156,
    -156,   -27,    17,     2,     2,     2,   299,   136,  -156,     2,
       2,   102,  -156,  -156,  -156,  -156,   299,   424,   299,   299,
     299,   299,   336,   336,   336,   336,   336,   336,   336,   336,
     336,   336,   336,   336,   336,   336,   336,   569,   170,  -156,
     479,   100,   166,   299,     6,   140,   151,   141,  -156,  -156,
     138,     4,   299,   299,  -156,    24,    24,  -156,  -156,  -156,
     165,   698,   185,   168,   178,   181,  -156,   118,   118,   118,
     118,   118,   118,   118,    68,   180,   180,   116,    89,   117,
     117,  -156,   184,    37,  -156,   518,   299,     7,   190,   218,
     219,   162,   163,   299,  -156,  -156,  -156,   214,  -156,    10,
    -156,   226,   227,   202,   698,  -156,   299,   197,   108,   299,
     186,     6,     6,    14,   233,   214,     2,     2,   164,   167,
    -156,   608,   608,   299,   212,  -156,   202,   211,   214,  -156,
     647,    19,   239,  -156,  -156,   182,   183,   188,     6,  -156,
    -156,  -156,    10,   213,   217,    38,   241,   222,  -156,   228,
    -156,   194,   299,   251,  -156,   252,   187,   189,  -156,  -156,
     238,   242,   262,   698,   243,  -156,  -156,   214,   647,   263,
      10,    10,  -156,  -156,   698,  -156,  -156,   209,   608,   198,
     210,  -156,  -156,   244,   282,   283,   264,   608,   608,  -156,
     258,   259,   267,   268,  -156,  -156
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -156,  -156,  -156,  -156,  -122,  -133,   287,   -22,  -156,    -6,
     191,   192,  -156,   111,  -156,  -156,  -156,  -156,    71,  -156,
    -156,   -21,  -156,   -25,   -30,    -3,   193,   195,   177,   179,
     -37,  -156,    36,   169,    57,   171,   199,    58,   -49,    -4,
     201,  -156,  -156,  -155,  -156,  -131,  -119,  -115,   145,    75,
     -76,    34
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -133
static const yytype_int16 yytable[] =
{
      31,   101,    33,    40,    92,    33,   100,   184,    11,   114,
      60,   112,    81,   190,    89,   182,    33,    96,   116,   107,
      31,   116,    33,   116,    93,   191,    11,   116,   203,   192,
      96,   116,    11,   116,    11,    82,     1,  -123,   115,   235,
     236,   117,    23,   -62,    42,   -62,    45,   209,    25,   137,
      86,    87,   116,    88,   216,   217,   233,   234,    27,   116,
     252,    21,    22,   207,     5,    83,    25,   237,   145,    84,
     262,    83,    25,   149,    25,    84,    31,   153,    33,   148,
     190,   190,   141,   258,   166,   106,   113,   181,   148,    31,
     153,    33,   191,   191,   151,   162,   192,   192,   199,   243,
     244,    76,    77,    78,   185,   104,   105,   190,   251,    46,
      47,    31,   230,    33,   116,    79,   146,   147,    80,   191,
     142,     4,   116,   192,     7,   200,   200,    90,   198,    94,
     275,    31,    91,    33,    31,    95,    33,   154,   155,   156,
     187,   281,   109,    42,    45,   110,   277,   130,   131,   197,
     103,    49,    50,    51,   111,    31,   283,    33,   167,   168,
     169,   170,   171,   172,   173,   290,   291,    53,    54,    55,
      56,   134,   135,    57,   122,   123,   124,   125,   118,    31,
     119,    33,   227,   208,   104,   105,   213,   175,   176,   120,
     215,   121,   179,   180,   279,   280,   129,   133,    31,   132,
      33,   136,   143,   228,   144,   152,   231,   183,  -109,   186,
     193,   194,   195,   196,   204,    31,    31,    33,    33,   205,
     245,   210,   211,   212,    31,   269,    33,   214,   116,   126,
     221,   222,   223,   220,   229,   127,   128,   238,   232,   241,
     242,   246,   249,   254,   260,   263,   255,   256,   261,   267,
     239,   240,   257,   264,   266,   268,   265,    31,    96,    33,
     272,   270,    31,   271,    33,   273,   274,   278,    31,   282,
      33,   276,    31,   284,    33,   286,   220,    96,    46,    47,
      48,    31,    31,    33,    33,   285,   287,   288,   289,   292,
     293,   294,   295,    28,   206,    11,   164,   248,   174,   165,
     157,   202,   158,   177,   220,   220,    46,    47,    48,   160,
       0,     0,   159,   163,     0,     0,     0,   259,     0,     0,
      49,    50,    51,    11,     0,    52,     0,     0,     0,    23,
       0,     0,   178,     0,     0,    25,    53,    54,    55,    56,
       0,     0,    57,    46,    47,    97,     0,     0,    49,    50,
      51,    58,     0,    52,     0,     0,     0,    23,     0,     0,
      11,     0,     0,    25,    53,    54,    55,    56,     0,     0,
      57,     0,     0,    27,     0,     0,     0,     0,     0,    58,
       0,     0,     0,     0,     0,    49,    50,    51,     8,     0,
      52,     0,     0,     0,    23,     0,     0,     0,     0,     0,
      25,    53,    54,    55,    56,     9,    10,    57,     0,    11,
      27,     0,    12,    13,     0,     0,    58,     0,    14,    15,
       0,    16,     0,     0,    17,     0,     0,     0,   161,     0,
       0,     0,     0,    18,     0,     0,     0,    19,    20,     0,
      21,    22,     0,    23,     9,    10,    24,     0,    11,    25,
       0,    12,    13,     0,    26,     0,     0,    14,    15,    27,
      16,     0,     0,    17,     0,     0,     0,     0,     0,     0,
       0,     0,    18,     0,     0,     0,     0,    20,     0,    21,
      22,     0,    23,     0,     0,    24,     0,     0,    25,     0,
       0,     0,     0,    26,     0,     0,     0,     0,    27,     9,
      10,  -132,  -132,    11,     0,     0,    12,    13,     0,     0,
       0,     0,    14,    15,     0,    16,     0,     0,    17,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    20,     0,    21,    22,     0,    23,     9,    10,
      24,     0,    11,    25,     0,    12,    13,     0,    26,     0,
       0,    14,    15,    27,    16,    -8,     0,    17,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,    20,     0,    21,    22,     0,    23,     0,     0,    24,
       0,     0,    25,     0,     0,     0,     0,    26,     0,     9,
      10,     0,    27,    11,     0,     0,    12,    13,     0,     0,
       0,     0,    14,    15,    -8,    16,     0,     0,    17,     0,
       0,     0,     0,     0,     0,     0,     0,    18,     0,     0,
       0,     0,    20,     0,    21,    22,     0,    23,     9,    10,
      24,     0,    11,    25,     0,    12,    13,     0,    26,    -8,
       0,    14,    15,    27,    16,     0,     0,    17,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,    20,     0,    21,    22,     0,    23,     9,    10,    24,
       0,    11,    25,     0,    12,    13,     0,    26,     0,     0,
      14,    15,    27,    16,     0,     0,    17,     0,     0,     0,
       0,     0,     0,     0,     0,    18,     0,     0,     0,     0,
      20,     0,    21,    22,     0,    23,     0,    -8,    24,     0,
       0,    25,     0,     0,     0,     0,    26,     0,     9,    10,
       0,    27,    11,     0,     0,    12,    13,     0,     0,     0,
       0,    14,    15,     0,    16,     0,     0,    17,     0,     0,
       0,     0,     0,     0,     0,     0,    18,     0,     0,     0,
       0,    20,     0,    21,    22,     0,    23,     0,     0,    24,
       0,     0,    25,     0,     0,     0,     0,    26,     0,     0,
       0,     0,    27
};

static const yytype_int16 yycheck[] =
{
       6,    31,     6,     9,    26,     9,    31,   140,    24,    58,
      13,    48,    15,   144,    20,   137,    20,     6,    14,    40,
      26,    14,    26,    14,    27,   144,    24,    14,   161,   144,
       6,    14,    24,    14,    24,     4,    46,    31,    59,    25,
      26,    32,    58,    70,    10,    72,    12,    40,    64,     4,
      42,    17,    14,    19,    44,    45,   211,   212,    74,    14,
      41,    55,    56,   185,     0,    34,    64,    53,    89,    38,
      32,    34,    64,    95,    64,    38,    82,    73,    82,    75,
     211,   212,    85,   238,   121,    74,    52,   136,    75,    95,
      73,    95,   211,   212,    97,   117,   211,   212,    74,   221,
     222,    22,    23,    24,     4,    22,    23,   238,   230,     7,
       8,   117,     4,   117,    14,    36,    62,    63,    39,   238,
      86,    47,    14,   238,     4,   155,   156,    57,   153,     4,
     263,   137,    59,   137,   140,    69,   140,   103,   104,   105,
     143,   274,    73,   109,   110,    73,   268,    79,    80,   152,
      72,    49,    50,    51,    70,   161,   278,   161,   122,   123,
     124,   125,   126,   127,   128,   287,   288,    65,    66,    67,
      68,    82,    83,    71,    15,    16,    17,    18,    13,   185,
      12,   185,   204,   186,    22,    23,    24,   130,   131,    11,
     193,    10,   134,   135,   270,   271,    78,    81,   204,    19,
     204,    84,    70,   206,     4,    70,   209,    37,    72,    43,
      70,    60,    71,    75,    29,   221,   222,   221,   222,    35,
     223,    31,     4,     4,   230,   255,   230,    64,    14,    70,
       4,     4,    30,   199,    37,    76,    77,     4,    52,    75,
      73,    29,    31,     4,    31,     4,    64,    64,    31,   252,
     216,   217,    64,    31,    60,     4,    28,   263,     6,   263,
      22,    74,   268,    74,   268,    23,     4,     4,   274,    60,
     274,    28,   278,    75,   278,    31,   242,     6,     7,     8,
       9,   287,   288,   287,   288,    75,     4,     4,    24,    31,
      31,    24,    24,     6,   183,    24,   119,   226,   129,   120,
     109,   156,   110,   132,   270,   271,     7,     8,     9,   116,
      -1,    -1,   111,   118,    -1,    -1,    -1,   242,    -1,    -1,
      49,    50,    51,    24,    -1,    54,    -1,    -1,    -1,    58,
      -1,    -1,   133,    -1,    -1,    64,    65,    66,    67,    68,
      -1,    -1,    71,     7,     8,    74,    -1,    -1,    49,    50,
      51,    80,    -1,    54,    -1,    -1,    -1,    58,    -1,    -1,
      24,    -1,    -1,    64,    65,    66,    67,    68,    -1,    -1,
      71,    -1,    -1,    74,    -1,    -1,    -1,    -1,    -1,    80,
      -1,    -1,    -1,    -1,    -1,    49,    50,    51,     3,    -1,
      54,    -1,    -1,    -1,    58,    -1,    -1,    -1,    -1,    -1,
      64,    65,    66,    67,    68,    20,    21,    71,    -1,    24,
      74,    -1,    27,    28,    -1,    -1,    80,    -1,    33,    34,
      -1,    36,    -1,    -1,    39,    -1,    -1,    -1,     4,    -1,
      -1,    -1,    -1,    48,    -1,    -1,    -1,    52,    53,    -1,
      55,    56,    -1,    58,    20,    21,    61,    -1,    24,    64,
      -1,    27,    28,    -1,    69,    -1,    -1,    33,    34,    74,
      36,    -1,    -1,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    48,    -1,    -1,    -1,    -1,    53,    -1,    55,
      56,    -1,    58,    -1,    -1,    61,    -1,    -1,    64,    -1,
      -1,    -1,    -1,    69,    -1,    -1,    -1,    -1,    74,    20,
      21,    22,    23,    24,    -1,    -1,    27,    28,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,
      -1,    -1,    53,    -1,    55,    56,    -1,    58,    20,    21,
      61,    -1,    24,    64,    -1,    27,    28,    -1,    69,    -1,
      -1,    33,    34,    74,    36,    37,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    53,    -1,    55,    56,    -1,    58,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    69,    -1,    20,
      21,    -1,    74,    24,    -1,    -1,    27,    28,    -1,    -1,
      -1,    -1,    33,    34,    35,    36,    -1,    -1,    39,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,
      -1,    -1,    53,    -1,    55,    56,    -1,    58,    20,    21,
      61,    -1,    24,    64,    -1,    27,    28,    -1,    69,    31,
      -1,    33,    34,    74,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    53,    -1,    55,    56,    -1,    58,    20,    21,    61,
      -1,    24,    64,    -1,    27,    28,    -1,    69,    -1,    -1,
      33,    34,    74,    36,    -1,    -1,    39,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,    -1,    -1,
      53,    -1,    55,    56,    -1,    58,    -1,    60,    61,    -1,
      -1,    64,    -1,    -1,    -1,    -1,    69,    -1,    20,    21,
      -1,    74,    24,    -1,    -1,    27,    28,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    -1,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    53,    -1,    55,    56,    -1,    58,    -1,    -1,    61,
      -1,    -1,    64,    -1,    -1,    -1,    -1,    69,    -1,    -1,
      -1,    -1,    74
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    46,    86,    87,    47,     0,    88,     4,     3,    20,
      21,    24,    27,    28,    33,    34,    36,    39,    48,    52,
      53,    55,    56,    58,    61,    64,    69,    74,    91,    92,
      93,    94,   100,   124,   126,   127,   130,   131,   132,   136,
      94,    95,   136,    96,    97,   136,     7,     8,     9,    49,
      50,    51,    54,    65,    66,    67,    68,    71,    80,    94,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,    22,    23,    24,    36,
      39,   110,     4,    34,    38,    98,    42,   136,   136,    94,
      57,    59,    92,   110,     4,    69,     6,    74,   106,   107,
     108,   109,   110,    72,    22,    23,    74,   106,   109,    73,
      73,    70,   115,   136,   123,   106,    14,    32,    13,    12,
      11,    10,    15,    16,    17,    18,    70,    76,    77,    78,
      79,    80,    19,    81,    82,    83,    84,     4,    89,    90,
      91,   110,   136,    70,     4,   106,    62,    63,    75,    92,
     108,   110,    70,    73,   136,   136,   136,    95,    96,   125,
     111,     4,    92,   112,   113,   114,   115,   117,   117,   117,
     117,   117,   117,   117,   118,   119,   119,   120,   121,   122,
     122,   123,    89,    37,    90,     4,    43,   110,   128,   129,
     130,   131,   132,    70,    60,    71,    75,   110,   108,    74,
     109,   133,   133,    90,    29,    35,    98,    89,   110,    40,
      31,     4,     4,    24,    64,   110,    44,    45,   134,   135,
     136,     4,     4,    30,   102,   103,   104,    92,   110,    37,
       4,   110,    52,   128,   128,    25,    26,    53,     4,   136,
     136,    75,    73,    89,    89,   110,    29,   105,   103,    31,
     101,    89,    41,    99,     4,    64,    64,    64,   128,   134,
      31,    31,    32,     4,    31,    28,    60,   110,     4,   109,
      74,    74,    22,    23,     4,    90,    28,    89,     4,   135,
     135,    90,    60,    89,    75,    75,    31,     4,     4,    24,
      89,    89,    31,    31,    24,    24
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 139 "parser.y"
    { parse_complete(ctx, (yyvsp[(1) - (3)].bool)); ;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 142 "parser.y"
    { (yyval.bool) = FALSE; ;}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 143 "parser.y"
    { (yyval.bool) = TRUE; ;}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 147 "parser.y"
    { source_add_statement(ctx, (yyvsp[(2) - (2)].statement)); ;}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 148 "parser.y"
    { source_add_class(ctx, (yyvsp[(2) - (2)].class_decl)); ;}
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 151 "parser.y"
    { (yyval.statement) = NULL; ;}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 152 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); ;}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 155 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); ;}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 156 "parser.y"
    { (yyval.statement) = link_statements((yyvsp[(1) - (2)].statement), (yyvsp[(2) - (2)].statement)); ;}
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 159 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (2)].statement); ;}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 162 "parser.y"
    { (yyval.statement) = NULL; ;}
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 163 "parser.y"
    { (yyval.statement) = (yyvsp[(2) - (2)].statement); ;}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 164 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); ;}
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 165 "parser.y"
    { (yyvsp[(1) - (3)].statement)->next = (yyvsp[(3) - (3)].statement); (yyval.statement) = (yyvsp[(1) - (3)].statement); ;}
    break;

  case 17:

/* Line 1464 of yacc.c  */
#line 166 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (2)].statement); ;}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 169 "parser.y"
    { (yyvsp[(1) - (2)].member)->args = (yyvsp[(2) - (2)].expression); (yyval.statement) = new_call_statement(ctx, (yyvsp[(1) - (2)].member)); CHECK_ERROR; ;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 170 "parser.y"
    { (yyvsp[(2) - (3)].member)->args = (yyvsp[(3) - (3)].expression); (yyval.statement) = new_call_statement(ctx, (yyvsp[(2) - (3)].member)); CHECK_ERROR; ;}
    break;

  case 20:

/* Line 1464 of yacc.c  */
#line 172 "parser.y"
    { (yyvsp[(1) - (4)].member)->args = (yyvsp[(2) - (4)].expression); (yyval.statement) = new_assign_statement(ctx, (yyvsp[(1) - (4)].member), (yyvsp[(4) - (4)].expression)); CHECK_ERROR; ;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 173 "parser.y"
    { (yyval.statement) = new_dim_statement(ctx, (yyvsp[(2) - (2)].dim_decl)); CHECK_ERROR; ;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 174 "parser.y"
    { (yyval.statement) = (yyvsp[(1) - (1)].statement); ;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 176 "parser.y"
    { (yyval.statement) = new_while_statement(ctx, STAT_WHILE, (yyvsp[(2) - (5)].expression), (yyvsp[(4) - (5)].statement)); CHECK_ERROR; ;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 178 "parser.y"
    { (yyval.statement) = new_while_statement(ctx, (yyvsp[(2) - (6)].bool) ? STAT_WHILELOOP : STAT_UNTIL, (yyvsp[(3) - (6)].expression), (yyvsp[(5) - (6)].statement));
                                              CHECK_ERROR; ;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 181 "parser.y"
    { (yyval.statement) = new_while_statement(ctx, (yyvsp[(5) - (6)].bool) ? STAT_DOWHILE : STAT_DOUNTIL, (yyvsp[(6) - (6)].expression), (yyvsp[(3) - (6)].statement));
                                              CHECK_ERROR; ;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 183 "parser.y"
    { (yyval.statement) = new_function_statement(ctx, (yyvsp[(1) - (1)].func_decl)); CHECK_ERROR; ;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 184 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_EXITDO, 0); CHECK_ERROR; ;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 185 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_EXITFOR, 0); CHECK_ERROR; ;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 186 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_EXITFUNC, 0); CHECK_ERROR; ;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 187 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_EXITPROP, 0); CHECK_ERROR; ;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 188 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_EXITSUB, 0); CHECK_ERROR; ;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 190 "parser.y"
    { (yyvsp[(2) - (5)].member)->args = (yyvsp[(3) - (5)].expression); (yyval.statement) = new_set_statement(ctx, (yyvsp[(2) - (5)].member), (yyvsp[(5) - (5)].expression)); CHECK_ERROR; ;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 191 "parser.y"
    { (yyval.statement) = new_statement(ctx, STAT_STOP, 0); CHECK_ERROR; ;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 192 "parser.y"
    { (yyval.statement) = new_onerror_statement(ctx, TRUE); CHECK_ERROR; ;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 193 "parser.y"
    { (yyval.statement) = new_onerror_statement(ctx, FALSE); CHECK_ERROR; ;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 194 "parser.y"
    { (yyval.statement) = new_const_statement(ctx, (yyvsp[(2) - (2)].const_decl)); CHECK_ERROR; ;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 196 "parser.y"
    { (yyval.statement) = new_forto_statement(ctx, (yyvsp[(2) - (10)].string), (yyvsp[(4) - (10)].expression), (yyvsp[(6) - (10)].expression), (yyvsp[(7) - (10)].expression), (yyvsp[(9) - (10)].statement)); CHECK_ERROR; ;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 198 "parser.y"
    { (yyval.statement) = new_foreach_statement(ctx, (yyvsp[(3) - (8)].string), (yyvsp[(5) - (8)].expression), (yyvsp[(7) - (8)].statement)); ;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 201 "parser.y"
    { (yyval.member) = new_member_expression(ctx, NULL, (yyvsp[(1) - (1)].string)); CHECK_ERROR; ;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 202 "parser.y"
    { (yyval.member) = new_member_expression(ctx, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].string)); CHECK_ERROR; ;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 205 "parser.y"
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[(1) - (1)].string), NULL); CHECK_ERROR; ;}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 206 "parser.y"
    { (yyval.dim_decl) = new_dim_decl(ctx, (yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].dim_decl)); CHECK_ERROR; ;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 209 "parser.y"
    { (yyval.const_decl) = (yyvsp[(1) - (1)].const_decl); ;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 210 "parser.y"
    { (yyvsp[(1) - (3)].const_decl)->next = (yyvsp[(3) - (3)].const_decl); (yyval.const_decl) = (yyvsp[(1) - (3)].const_decl); ;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 213 "parser.y"
    { (yyval.const_decl) = new_const_decl(ctx, (yyvsp[(1) - (3)].string), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 216 "parser.y"
    { (yyval.bool) = TRUE; ;}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 217 "parser.y"
    { (yyval.bool) = FALSE; ;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 220 "parser.y"
    { (yyval.expression) = NULL;;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 221 "parser.y"
    { (yyval.expression) = (yyvsp[(2) - (2)].expression); ;}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 225 "parser.y"
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[(2) - (9)].expression), (yyvsp[(5) - (9)].statement), (yyvsp[(6) - (9)].elseif), (yyvsp[(7) - (9)].statement)); CHECK_ERROR; ;}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 226 "parser.y"
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[(2) - (4)].expression), (yyvsp[(4) - (4)].statement), NULL, NULL); CHECK_ERROR; ;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 228 "parser.y"
    { (yyval.statement) = new_if_statement(ctx, (yyvsp[(2) - (7)].expression), (yyvsp[(4) - (7)].statement), NULL, (yyvsp[(6) - (7)].statement)); CHECK_ERROR; ;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 235 "parser.y"
    { (yyval.elseif) = NULL; ;}
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 236 "parser.y"
    { (yyval.elseif) = (yyvsp[(1) - (1)].elseif); ;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 239 "parser.y"
    { (yyval.elseif) = (yyvsp[(1) - (1)].elseif); ;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 240 "parser.y"
    { (yyvsp[(1) - (2)].elseif)->next = (yyvsp[(2) - (2)].elseif); (yyval.elseif) = (yyvsp[(1) - (2)].elseif); ;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 244 "parser.y"
    { (yyval.elseif) = new_elseif_decl(ctx, (yyvsp[(2) - (5)].expression), (yyvsp[(5) - (5)].statement)); ;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 247 "parser.y"
    { (yyval.statement) = NULL; ;}
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 248 "parser.y"
    { (yyval.statement) = (yyvsp[(3) - (3)].statement); ;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 251 "parser.y"
    { (yyval.expression) = NULL; ;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 252 "parser.y"
    { (yyval.expression) = (yyvsp[(2) - (3)].expression); ;}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 255 "parser.y"
    { (yyval.expression) = NULL; ;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 256 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 259 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 260 "parser.y"
    { (yyvsp[(1) - (3)].expression)->next = (yyvsp[(3) - (3)].expression); (yyval.expression) = (yyvsp[(1) - (3)].expression); ;}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 267 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 268 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IMP, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 271 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 272 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EQV, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 275 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 276 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_XOR, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 279 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 280 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_OR, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 283 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 284 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_AND, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 287 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 288 "parser.y"
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NOT, (yyvsp[(2) - (2)].expression)); CHECK_ERROR; ;}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 291 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 292 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EQUAL, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 293 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_NEQUAL, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 294 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_GT, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 295 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_LT, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 296 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_GTEQ, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 297 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_LTEQ, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 298 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IS, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 301 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 302 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_CONCAT, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 305 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 306 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_ADD, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 307 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_SUB, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 310 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 311 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_MOD, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 314 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 316 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_IDIV, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 319 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 321 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_MUL, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 323 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_DIV, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 326 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 327 "parser.y"
    { (yyval.expression) = new_binary_expression(ctx, EXPR_EXP, (yyvsp[(1) - (3)].expression), (yyvsp[(3) - (3)].expression)); CHECK_ERROR; ;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 330 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 331 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 332 "parser.y"
    { (yyval.expression) = new_new_expression(ctx, (yyvsp[(2) - (2)].string)); CHECK_ERROR; ;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 333 "parser.y"
    { (yyval.expression) = new_unary_expression(ctx, EXPR_NEG, (yyvsp[(2) - (2)].expression)); CHECK_ERROR; ;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 336 "parser.y"
    { (yyval.expression) = (yyvsp[(1) - (1)].expression); ;}
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 337 "parser.y"
    { (yyvsp[(1) - (2)].member)->args = (yyvsp[(2) - (2)].expression); (yyval.expression) = &(yyvsp[(1) - (2)].member)->expr; ;}
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 340 "parser.y"
    { (yyval.expression) = new_bool_expression(ctx, VARIANT_TRUE); CHECK_ERROR; ;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 341 "parser.y"
    { (yyval.expression) = new_bool_expression(ctx, VARIANT_FALSE); CHECK_ERROR; ;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 342 "parser.y"
    { (yyval.expression) = new_string_expression(ctx, (yyvsp[(1) - (1)].string)); CHECK_ERROR; ;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 343 "parser.y"
    { (yyval.expression) = new_long_expression(ctx, EXPR_USHORT, (yyvsp[(1) - (1)].lng)); CHECK_ERROR; ;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 344 "parser.y"
    { (yyval.expression) = new_long_expression(ctx, EXPR_USHORT, 0); CHECK_ERROR; ;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 345 "parser.y"
    { (yyval.expression) = new_long_expression(ctx, EXPR_ULONG, (yyvsp[(1) - (1)].lng)); CHECK_ERROR; ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 346 "parser.y"
    { (yyval.expression) = new_double_expression(ctx, (yyvsp[(1) - (1)].dbl)); CHECK_ERROR; ;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 347 "parser.y"
    { (yyval.expression) = new_expression(ctx, EXPR_EMPTY, 0); CHECK_ERROR; ;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 348 "parser.y"
    { (yyval.expression) = new_expression(ctx, EXPR_NULL, 0); CHECK_ERROR; ;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 349 "parser.y"
    { (yyval.expression) = new_expression(ctx, EXPR_NOTHING, 0); CHECK_ERROR; ;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 352 "parser.y"
    { (yyval.expression) = (yyvsp[(2) - (3)].expression); ;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 353 "parser.y"
    { (yyval.expression) = new_expression(ctx, EXPR_ME, 0); CHECK_ERROR; ;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 356 "parser.y"
    { (yyvsp[(4) - (7)].class_decl)->name = (yyvsp[(2) - (7)].string); (yyval.class_decl) = (yyvsp[(4) - (7)].class_decl); ;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 359 "parser.y"
    { (yyval.class_decl) = new_class_decl(ctx); ;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 360 "parser.y"
    { (yyval.class_decl) = add_class_function(ctx, (yyvsp[(3) - (3)].class_decl), (yyvsp[(1) - (3)].func_decl)); CHECK_ERROR; ;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 361 "parser.y"
    { (yyval.class_decl) = add_variant_prop(ctx, (yyvsp[(4) - (4)].class_decl), (yyvsp[(2) - (4)].string), (yyvsp[(1) - (4)].uint)); CHECK_ERROR; ;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 362 "parser.y"
    { (yyval.class_decl) = add_class_function(ctx, (yyvsp[(3) - (3)].class_decl), (yyvsp[(1) - (3)].func_decl)); CHECK_ERROR; ;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 366 "parser.y"
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[(4) - (9)].string), FUNC_PROPGET, (yyvsp[(1) - (9)].uint), NULL, (yyvsp[(7) - (9)].statement)); CHECK_ERROR; ;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 368 "parser.y"
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[(4) - (11)].string), FUNC_PROPLET, (yyvsp[(1) - (11)].uint), (yyvsp[(6) - (11)].arg_decl), (yyvsp[(9) - (11)].statement)); CHECK_ERROR; ;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 370 "parser.y"
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[(4) - (11)].string), FUNC_PROPSET, (yyvsp[(1) - (11)].uint), (yyvsp[(6) - (11)].arg_decl), (yyvsp[(9) - (11)].statement)); CHECK_ERROR; ;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 374 "parser.y"
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[(3) - (8)].string), FUNC_SUB, (yyvsp[(1) - (8)].uint), (yyvsp[(4) - (8)].arg_decl), (yyvsp[(6) - (8)].statement)); CHECK_ERROR; ;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 376 "parser.y"
    { (yyval.func_decl) = new_function_decl(ctx, (yyvsp[(3) - (8)].string), FUNC_FUNCTION, (yyvsp[(1) - (8)].uint), (yyvsp[(4) - (8)].arg_decl), (yyvsp[(6) - (8)].statement)); CHECK_ERROR; ;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 379 "parser.y"
    { (yyval.uint) = 0; ;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 380 "parser.y"
    { (yyval.uint) = (yyvsp[(1) - (1)].uint); ;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 383 "parser.y"
    { (yyval.uint) = STORAGE_IS_DEFAULT; ;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 384 "parser.y"
    { (yyval.uint) = 0; ;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 385 "parser.y"
    { (yyval.uint) = STORAGE_IS_PRIVATE; ;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 388 "parser.y"
    { (yyval.arg_decl) = NULL; ;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 389 "parser.y"
    { (yyval.arg_decl) = (yyvsp[(2) - (3)].arg_decl); ;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 392 "parser.y"
    { (yyval.arg_decl) = (yyvsp[(1) - (1)].arg_decl); ;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 393 "parser.y"
    { (yyvsp[(1) - (3)].arg_decl)->next = (yyvsp[(3) - (3)].arg_decl); (yyval.arg_decl) = (yyvsp[(1) - (3)].arg_decl); ;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 396 "parser.y"
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[(1) - (1)].string), TRUE); ;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 397 "parser.y"
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[(2) - (2)].string), TRUE); ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 398 "parser.y"
    { (yyval.arg_decl) = new_argument_decl(ctx, (yyvsp[(2) - (2)].string), FALSE); ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 402 "parser.y"
    { (yyval.string) = (yyvsp[(1) - (1)].string); ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 403 "parser.y"
    { (yyval.string) = propertyW; ;}
    break;



/* Line 1464 of yacc.c  */
#line 2833 "parser.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 404 "parser.y"


static int parser_error(const char *str)
{
    return 0;
}

static void source_add_statement(parser_ctx_t *ctx, statement_t *stat)
{
    if(!stat)
        return;

    if(ctx->stats) {
        ctx->stats_tail->next = stat;
        ctx->stats_tail = stat;
    }else {
        ctx->stats = ctx->stats_tail = stat;
    }
}

static void source_add_class(parser_ctx_t *ctx, class_decl_t *class_decl)
{
    class_decl->next = ctx->class_decls;
    ctx->class_decls = class_decl;
}

static void parse_complete(parser_ctx_t *ctx, BOOL option_explicit)
{
    ctx->parse_complete = TRUE;
    ctx->option_explicit = option_explicit;
}

static void *new_expression(parser_ctx_t *ctx, expression_type_t type, size_t size)
{
    expression_t *expr;

    expr = parser_alloc(ctx, size ? size : sizeof(*expr));
    if(expr) {
        expr->type = type;
        expr->next = NULL;
    }

    return expr;
}

static expression_t *new_bool_expression(parser_ctx_t *ctx, VARIANT_BOOL value)
{
    bool_expression_t *expr;

    expr = new_expression(ctx, EXPR_BOOL, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_string_expression(parser_ctx_t *ctx, const WCHAR *value)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_STRING, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_long_expression(parser_ctx_t *ctx, expression_type_t type, LONG value)
{
    int_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_double_expression(parser_ctx_t *ctx, double value)
{
    double_expression_t *expr;

    expr = new_expression(ctx, EXPR_DOUBLE, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = value;
    return &expr->expr;
}

static expression_t *new_unary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *subexpr)
{
    unary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->subexpr = subexpr;
    return &expr->expr;
}

static expression_t *new_binary_expression(parser_ctx_t *ctx, expression_type_t type, expression_t *left, expression_t *right)
{
    binary_expression_t *expr;

    expr = new_expression(ctx, type, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->left = left;
    expr->right = right;
    return &expr->expr;
}

static member_expression_t *new_member_expression(parser_ctx_t *ctx, expression_t *obj_expr, const WCHAR *identifier)
{
    member_expression_t *expr;

    expr = new_expression(ctx, EXPR_MEMBER, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->obj_expr = obj_expr;
    expr->identifier = identifier;
    expr->args = NULL;
    return expr;
}

static expression_t *new_new_expression(parser_ctx_t *ctx, const WCHAR *identifier)
{
    string_expression_t *expr;

    expr = new_expression(ctx, EXPR_NEW, sizeof(*expr));
    if(!expr)
        return NULL;

    expr->value = identifier;
    return &expr->expr;
}

static void *new_statement(parser_ctx_t *ctx, statement_type_t type, size_t size)
{
    statement_t *stat;

    stat = parser_alloc(ctx, size ? size : sizeof(*stat));
    if(stat) {
        stat->type = type;
        stat->next = NULL;
    }

    return stat;
}

static statement_t *new_call_statement(parser_ctx_t *ctx, member_expression_t *expr)
{
    call_statement_t *stat;

    stat = new_statement(ctx, STAT_CALL, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    return &stat->stat;
}

static statement_t *new_assign_statement(parser_ctx_t *ctx, member_expression_t *left, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_ASSIGN, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->member_expr = left;
    stat->value_expr = right;
    return &stat->stat;
}

static statement_t *new_set_statement(parser_ctx_t *ctx, member_expression_t *left, expression_t *right)
{
    assign_statement_t *stat;

    stat = new_statement(ctx, STAT_SET, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->member_expr = left;
    stat->value_expr = right;
    return &stat->stat;
}

static dim_decl_t *new_dim_decl(parser_ctx_t *ctx, const WCHAR *name, dim_decl_t *next)
{
    dim_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->next = next;
    return decl;
}

static statement_t *new_dim_statement(parser_ctx_t *ctx, dim_decl_t *decls)
{
    dim_statement_t *stat;

    stat = new_statement(ctx, STAT_DIM, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->dim_decls = decls;
    return &stat->stat;
}

static elseif_decl_t *new_elseif_decl(parser_ctx_t *ctx, expression_t *expr, statement_t *stat)
{
    elseif_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->expr = expr;
    decl->stat = stat;
    decl->next = NULL;
    return decl;
}

static statement_t *new_while_statement(parser_ctx_t *ctx, statement_type_t type, expression_t *expr, statement_t *body)
{
    while_statement_t *stat;

    stat = new_statement(ctx, type, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_forto_statement(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *from_expr,
        expression_t *to_expr, expression_t *step_expr, statement_t *body)
{
    forto_statement_t *stat;

    stat = new_statement(ctx, STAT_FORTO, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->from_expr = from_expr;
    stat->to_expr = to_expr;
    stat->step_expr = step_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_foreach_statement(parser_ctx_t *ctx, const WCHAR *identifier, expression_t *group_expr,
        statement_t *body)
{
    foreach_statement_t *stat;

    stat = new_statement(ctx, STAT_FOREACH, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->identifier = identifier;
    stat->group_expr = group_expr;
    stat->body = body;
    return &stat->stat;
}

static statement_t *new_if_statement(parser_ctx_t *ctx, expression_t *expr, statement_t *if_stat, elseif_decl_t *elseif_decl,
        statement_t *else_stat)
{
    if_statement_t *stat;

    stat = new_statement(ctx, STAT_IF, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->expr = expr;
    stat->if_stat = if_stat;
    stat->elseifs = elseif_decl;
    stat->else_stat = else_stat;
    return &stat->stat;
}

static statement_t *new_onerror_statement(parser_ctx_t *ctx, BOOL resume_next)
{
    onerror_statement_t *stat;

    stat = new_statement(ctx, STAT_ONERROR, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->resume_next = resume_next;
    return &stat->stat;
}

static arg_decl_t *new_argument_decl(parser_ctx_t *ctx, const WCHAR *name, BOOL by_ref)
{
    arg_decl_t *arg_decl;

    arg_decl = parser_alloc(ctx, sizeof(*arg_decl));
    if(!arg_decl)
        return NULL;

    arg_decl->name = name;
    arg_decl->by_ref = by_ref;
    arg_decl->next = NULL;
    return arg_decl;
}

static function_decl_t *new_function_decl(parser_ctx_t *ctx, const WCHAR *name, function_type_t type,
        unsigned storage_flags, arg_decl_t *arg_decl, statement_t *body)
{
    function_decl_t *decl;

    if(storage_flags & STORAGE_IS_DEFAULT) {
        if(type == FUNC_PROPGET) {
            type = FUNC_DEFGET;
        }else {
            FIXME("Invalid default property\n");
            ctx->hres = E_FAIL;
            return NULL;
        }
    }

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->type = type;
    decl->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    decl->args = arg_decl;
    decl->body = body;
    decl->next = NULL;
    decl->next_prop_func = NULL;
    return decl;
}

static statement_t *new_function_statement(parser_ctx_t *ctx, function_decl_t *decl)
{
    function_statement_t *stat;

    stat = new_statement(ctx, STAT_FUNC, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->func_decl = decl;
    return &stat->stat;
}

static class_decl_t *new_class_decl(parser_ctx_t *ctx)
{
    class_decl_t *class_decl;

    class_decl = parser_alloc(ctx, sizeof(*class_decl));
    if(!class_decl)
        return NULL;

    class_decl->funcs = NULL;
    class_decl->props = NULL;
    class_decl->next = NULL;
    return class_decl;
}

static class_decl_t *add_class_function(parser_ctx_t *ctx, class_decl_t *class_decl, function_decl_t *decl)
{
    function_decl_t *iter;

    for(iter = class_decl->funcs; iter; iter = iter->next) {
        if(!strcmpiW(iter->name, decl->name)) {
            if(decl->type == FUNC_SUB || decl->type == FUNC_FUNCTION) {
                FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                ctx->hres = E_FAIL;
                return NULL;
            }

            while(1) {
                if(iter->type == decl->type) {
                    FIXME("Redefinition of %s::%s\n", debugstr_w(class_decl->name), debugstr_w(decl->name));
                    ctx->hres = E_FAIL;
                    return NULL;
                }
                if(!iter->next_prop_func)
                    break;
                iter = iter->next_prop_func;
            }

            iter->next_prop_func = decl;
            return class_decl;
        }
    }

    decl->next = class_decl->funcs;
    class_decl->funcs = decl;
    return class_decl;
}

static class_decl_t *add_variant_prop(parser_ctx_t *ctx, class_decl_t *class_decl, const WCHAR *identifier, unsigned storage_flags)
{
    class_prop_decl_t *prop;

    if(storage_flags & STORAGE_IS_DEFAULT) {
        FIXME("variant prop van't be default value\n");
        ctx->hres = E_FAIL;
        return NULL;
    }

    prop = parser_alloc(ctx, sizeof(*prop));
    if(!prop)
        return NULL;

    prop->name = identifier;
    prop->is_public = !(storage_flags & STORAGE_IS_PRIVATE);
    prop->next = class_decl->props;
    class_decl->props = prop;
    return class_decl;
}

static const_decl_t *new_const_decl(parser_ctx_t *ctx, const WCHAR *name, expression_t *expr)
{
    const_decl_t *decl;

    decl = parser_alloc(ctx, sizeof(*decl));
    if(!decl)
        return NULL;

    decl->name = name;
    decl->value_expr = expr;
    decl->next = NULL;
    return decl;
}

static statement_t *new_const_statement(parser_ctx_t *ctx, const_decl_t *decls)
{
    const_statement_t *stat;

    stat = new_statement(ctx, STAT_CONST, sizeof(*stat));
    if(!stat)
        return NULL;

    stat->decls = decls;
    return &stat->stat;
}

static statement_t *link_statements(statement_t *head, statement_t *tail)
{
    statement_t *iter;

    for(iter = head; iter->next; iter = iter->next);
    iter->next = tail;

    return head;
}

void *parser_alloc(parser_ctx_t *ctx, size_t size)
{
    void *ret;

    ret = vbsheap_alloc(&ctx->heap, size);
    if(!ret)
        ctx->hres = E_OUTOFMEMORY;
    return ret;
}

HRESULT parse_script(parser_ctx_t *ctx, const WCHAR *code)
{
    ctx->code = ctx->ptr = code;
    ctx->end = ctx->code + strlenW(ctx->code);

    vbsheap_init(&ctx->heap);

    ctx->parse_complete = FALSE;
    ctx->hres = S_OK;

    ctx->last_token = tNL;
    ctx->last_nl = 0;
    ctx->stats = ctx->stats_tail = NULL;
    ctx->class_decls = NULL;
    ctx->option_explicit = FALSE;

    parser_parse(ctx);

    if(FAILED(ctx->hres))
        return ctx->hres;
    if(!ctx->parse_complete) {
        FIXME("parser failed on parsing %s\n", debugstr_w(ctx->ptr));
        return E_FAIL;
    }

    return S_OK;
}

void parser_release(parser_ctx_t *ctx)
{
    vbsheap_free(&ctx->heap);
}

